#include <iostream>
#include <string>
#include <vector>
using namespace std;

struct Node {
  bool end;
  int children[26];
  Node(bool e){
    end = e;
    for (int i = 0; i < 26; ++i) children[i] = -1;
  }
};

void insert(vector<Node> & tree, const string & s){

  int cur = 0;
  for (int i = s.size() - 1; i >= 0; --i){
    if (tree[cur].children[s[i] - 'a'] == -1){
      tree[cur].children[s[i] - 'a'] = tree.size();
      tree.push_back(Node(false));
    }
    cur = tree[cur].children[s[i] - 'a'];
  }
  tree[cur].end = true;
}

int main(){
  int n;
  cin >> n;
  string line;
  getline(cin, line);
  vector<Node> tree(1, Node(false));
  while (n--){
    getline(cin, line);
    insert(tree, line);
  }
  cin >> n;
  getline(cin, line);
  while (n--){
    getline(cin, line);
    vector<bool> v(line.size() + 1, false);
    v[0] = true;
    for (int i = 0; i < line.size(); ++i){
      int cur = 0;
      for (int j = i; j >= 0; --j){
        if (tree[cur].children[line[j] - 'a'] == -1) break;
        cur = tree[cur].children[line[j] - 'a'];
        if (tree[cur].end && v[j]){
          v[i+1] = true;
          break;
        }
      }
    }
    if (v[line.size()]) cout << "Yes\n";
    else cout << "No\n";
  }
}
